## bpftune 0.0~git20241205.2a8d043

=== src/Makefile ===
# SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
#
# Copyright (c) 2023, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License v2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#

SRCARCH ?= $(shell uname -m | sed -e s/i.86/x86/ -e s/x86_64/x86/ \
				  -e /arm64/!s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/aarch64.*/arm64/ )

CLANG ?= clang
GCC_BPF ?=
LLC ?= llc
LLVM_STRIP ?= llvm-strip
BPFTOOL ?= bpftool
BPF_INCLUDE := /usr/include
BPF_CFLAGS := -g -fno-stack-protector -Wall
NL_INCLUDE := /usr/include/libnl3
INCLUDES := -I../include -I$(BPF_INCLUDE) -I$(NL_INCLUDE) -I../include/uapi
INSTALL ?= install

DESTDIR ?= /
prefix ?= /usr
libdir ?= lib64
installprefix = $(DESTDIR)/$(prefix)

INSTALLPATH = $(installprefix)

# Prefix path can be /usr, /usr/local or for packaging case
# /path2rpmbuilddir/usr[/local]. We use the /usr path as a guide
# to where to bisect the full path such that everything prior to
# it is considered to be prefix to config path /etc.
confprefix ?= $(shell echo $(prefix) | awk -F /usr '{ printf $1 "/etc" }')
CONF	 = $(DESTDIR)/$(confprefix)
CONFPATH  = $(CONF)/ld.so.conf.d

KERNEL_REL := $(shell uname -r)
GIT_SHA := $(shell git rev-parse HEAD)

ifeq ($(BPFTUNE_VERSION),)
BPFTUNE_VERSION := $(KERNEL_REL)-$(GIT_SHA)
endif

VERSION = 0.1.3
VERSION_SCRIPT  := libbpftune.map

CFLAGS = -fPIC -Wall -Wextra -g -I../include -std=c99

CFLAGS += -DBPFTUNE_VERSION='"$(BPFTUNE_VERSION)"' \
	  -DBPFTUNER_PREFIX_DIR='"$(prefix)"' \
	  -DLIB_DIR='"$(libdir)"' \
	  $(INCLUDES)

LDLIBS = -lbpf -ldl -lm -lrt -lcap -lnl-3 -lpthread -lnl-route-3

LDFLAGS += -L. -L$(prefix)/$(libdir)

# Try to detect best kernel BTF source
KERNEL_REL := $(shell uname -r)
VMLINUX_BTF_PATHS := /sys/kernel/btf/vmlinux /boot/vmlinux-$(KERNEL_REL)
VMLINUX_BTF_PATH := $(or $(VMLINUX_BTF),$(firstword			       \
					  $(wildcard $(VMLINUX_BTF_PATHS))))

OPATH :=
ifeq ($(SANITIZE),1)
CFLAGS += -fsanitize=address 
OPATH := .sanitize/
endif

ifeq ($(V),1)
Q =
else
Q = @
MAKEFLAGS += --no-print-directory
submake_extras := feature_display=0
endif

TUNERS = tcp_buffer_tuner route_table_tuner neigh_table_tuner sysctl_tuner \
	 tcp_conn_tuner netns_tuner net_buffer_tuner ip_frag_tuner

TUNER_OBJS = $(patsubst %,%.o,$(TUNERS))
TUNER_SRCS = $(patsubst %,%.c,$(TUNERS))
TUNER_LIBS = $(patsubst %,$(OPATH)%.so,$(TUNERS))

BPF_TUNERS = $(patsubst %,%.bpf.o,$(TUNERS))

BPF_OBJS = $(BPF_TUNERS) probe.bpf.o
LEGACY_BPF_OBJS = $(patsubst %.bpf.o,%.bpf.legacy.o,$(BPF_OBJS))
NOBTF_BPF_OBJS = $(patsubst %.bpf.o,%.bpf.nobtf.o,$(BPF_OBJS))

BPF_SKELS = $(patsubst %,%.skel.h,$(TUNERS)) probe.skel.h
LEGACY_BPF_SKELS = $(patsubst %.skel.h,%.skel.legacy.h,$(BPF_SKELS))
NOBTF_BPF_SKELS = $(patsubst %.skel.h,%.skel.nobtf.h,$(BPF_SKELS))

BPFTUNE_HDRS = ../include/bpftune/libbpftune.h \
	       ../include/bpftune/bpftune.h

.DELETE_ON_ERROR:

.PHONY: clean

ifeq ($(GCC_BPF),)
all: analyze $(OPATH) $(OPATH)bpftune $(TUNER_LIBS)
else
all: $(OPATH) $(OPATH)bpftune $(TUNER_LIBS)
endif

$(OPATH):
	mkdir $(OPATH)

analyze: $(BPF_SKELS) $(LEGACY_BPF_SKELS) $(NOBTF_BPF_SKELS)
	$(CLANG) --analyze $(INCLUDES) libbpftune.c bpftune.c $(TUNER_SRCS)
clean:
	$(call QUIET_CLEAN, bpftune)
	$(Q)$(RM) $(OPATH)*.o *.d $(OPATH)*.so*
	$(Q)$(RM) *.o *.so*
	$(Q)$(RM) *.skel.*h
	$(Q)$(RM) bpftune

distclean: clean
	$(Q)$(RM) -r .output .sanitize

install: $(OPATH)libbpftune.so $(OPATH)bpftune bpftune.service
	$(INSTALL) -m 0755 -d $(INSTALLPATH)/sbin
	$(INSTALL) $(OPATH)bpftune $(INSTALLPATH)/sbin/bpftune
	$(INSTALL) -m 0755 -d $(INSTALLPATH)/$(libdir)
	$(INSTALL) $(OPATH)libbpftune.so* $(INSTALLPATH)/$(libdir)
	$(INSTALL) -m 0755 -d $(installprefix)/lib/systemd/system
	$(INSTALL) -m 644 bpftune.service $(installprefix)/lib/systemd/system
	$(INSTALL) -m 0755 -d $(INSTALLPATH)/$(libdir)/bpftune
	$(INSTALL) $(TUNER_LIBS) $(INSTALLPATH)/$(libdir)/bpftune
	$(INSTALL) -m 0755 -d $(CONF)
	$(INSTALL) -m 0755 -d $(CONFPATH)
	echo $(prefix)/$(libdir) > $(CONFPATH)/libbpftune.conf
	if [ $(DESTDIR) =  / ]; then ldconfig; fi

$(OPATH)bpftune: bpftune.c $(OPATH)bpftune.o $(OPATH)libbpftune.so
	$(QUIET_LINK)$(CC) $(CFLAGS) $(OPATH)bpftune.o -o $@ \
	$(LDFLAGS) $(LDLIBS) -lbpftune

$(OPATH)libbpftune.so: libbpftune.c $(BPFTUNE_HDRS) $(OPATH)libbpftune.o
	$(CC) $(CFLAGS) -Wl,--version-script=$(VERSION_SCRIPT) \
			-Wl,--soname,$(notdir $@).$(VERSION) \
			-shared -o $(@).$(VERSION) \
			$(patsubst %.so,%.o,$(@)) \
			$(LDLIBS) $(LDFLAGS) ; \
	rm -f $(@) ; \
	ln -sr $(@).$(VERSION) $(@)

$(TUNER_OBJS): $(BPF_SKELS) $(LEGACY_BPF_SKELS) $(NOBTF_BPF_SKELS)

$(TUNER_LIBS): $(OPATH)libbpftune.so $(TUNER_OBJS)
	$(CC) $(CFLAGS) -shared -o $(@) $(patsubst $(OPATH)%.so,%.c,$(@)) \
		$(LDLIBS) -lbpftune $(LDFLAGS)

$(OPATH)libbpftune.o: probe.skel.h probe.skel.legacy.h probe.skel.nobtf.h libbpftune.c
	$(QUIET_CC)$(CC) $(CFLAGS) -c libbpftune.c -o $@

$(OPATH)bpftune.o: $(OPATH)libbpftune.so
	$(QUIET_CC)$(CC) $(CFLAGS) -c bpftune.c -o $@

%.skel.h: %.bpf.o
	$(QUIET_GEN)$(BPFTOOL) gen skeleton $< > $@

# check if GCC_BPF flag is set, otherwise use CLANG
ifeq ($(GCC_BPF),)
$(BPF_OBJS): $(patsubst %.o,%.c,$(BPF_OBJS)) ../include/bpftune/bpftune.bpf.h
	$(CLANG) $(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) -O2 -target bpf \
		$(INCLUDES) -c $(patsubst %.o,%.c,$(@)) -o $(@)

$(LEGACY_BPF_OBJS): $(patsubst %.legacy.o,%.c,$(LEGACY_BPF_OBJS)) ../include/bpftune/bpftune.bpf.h
	$(CLANG) $(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) -DBPFTUNE_LEGACY -O2 -target bpf \
		$(INCLUDES) -c $(patsubst %.legacy.o,%.c,$(@)) \
		-o $(@)

$(NOBTF_BPF_OBJS): $(patsubst %.nobtf.o,%.c,$(NOBTF_BPF_OBJS)) ../include/bpftune/bpftune.bpf.h
	$(CLANG) $(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) -DBPFTUNE_NOBTF -O2 -target bpf \
		$(INCLUDES) -c $(patsubst %.nobtf.o,%.c,$(@)) \
		-o $(@)
else
GCC_BPF_FLAGS := -g -O2 \
	$(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) \
	-gbtf -mcpu=v3 -Wno-error=attributes \
	-Wno-error=address-of-packed-member \
	-Wno-compare-distinct-pointer-types \
	$(INCLUDES)

$(BPF_OBJS): $(patsubst %.o,%.c,$(BPF_OBJS)) ../include/bpftune/bpftune.bpf.h
	$(GCC_BPF) $(GCC_BPF_FLAGS) -c $(patsubst %.o,%.c,$(@)) \
		-o $(@)

$(LEGACY_BPF_OBJS): $(patsubst %.legacy.o,%.c,$(LEGACY_BPF_OBJS)) ../include/bpftune/bpftune.bpf.h
	$(GCC_BPF) $(GCC_BPF_FLAGS) -DBPFTUNE_LEGACY -c $(patsubst %.legacy.o,%.c,$(@)) \
		-o $(@)

$(NOBTF_BPF_OBJS): $(patsubst %.nobtf.o,%.c,$(NOBTF_BPF_OBJS)) ../include/bpftune/bpftune.bpf.h
	$(GCC_BPF) $(GCC_BPF_FLAGS) -DBPFTUNE_NOBTF -c $(patsubst %.nobtf.o,%.c,$(@)) \
		-o $(@)
endif

$(BPF_SKELS): $(BPF_OBJS)
	$(BPFTOOL) gen skeleton $(subst .skel.h,.bpf.o,$@) > $@

$(LEGACY_BPF_SKELS): $(LEGACY_BPF_OBJS)
	$(BPFTOOL) gen skeleton $(subst .skel.legacy.h,.bpf.legacy.o,$@) > $(subst .skel.h,.skel.legacy.h,$@)

$(NOBTF_BPF_SKELS): $(NOBTF_BPF_OBJS)
	$(BPFTOOL) gen skeleton $(subst .skel.nobtf.h,.bpf.nobtf.o,$@) > $(subst .skel.h,.skel.nobtf.h,$@)

=== test/Makefile ===
# SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
#
# Copyright (c) 2023, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License v2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#


PERF_TESTS = iperf3_test qperf_test

TUNER_TESTS =	support_test log_test service_test inotify_test cap_test \
		sample_test sample_legacy_test \
		strategy_test strategy_legacy_test \
		rollback_test rollback_legacy_test \
		many_netns_test many_netns_legacy_test \
		podman_globalonly_test podman_globalonly_legacy_test \
		sysctl_test sysctl_legacy_test sysctl_netns_test \
		netns_test netns_legacy_test \
		budget_test \
		backlog_test backlog_legacy_test \
		frag_test frag_legacy_test \
		neigh_table_test neigh_table_v4only_test \
		neigh_table_legacy_test \
		mem_pressure_test mem_pressure_legacy_test \
		mem_exhaust_test mem_exhaust_legacy_test \
		wmem_test wmem_legacy_test \
		rmem_test rmem_legacy_test \
		cong_test cong_legacy_test

DEFAULT_TESTS = $(TUNER_TESTS) $(PERF_TESTS)

TESTS = $(DEFAULT_TESTS)

LIBS = test_lib.sh

PROGS = conn_bomb

OBJS = conn_bomb.o

INSTALLFILES = $(DEFAULT_TESTS:%=%.sh) $(LIBS)

DESTDIR ?=
prefix ?= /usr
installprefix ?= $(DESTDIR)/$(prefix)

INSTALLPATH = $(installprefix)/lib/tcptune_test/

install_sh_PROGRAM = install
install_sh_DIR = install -dv

all: strategydir $(PROGS)
	
strategydir:
	cd strategy; make

PHONY: clean
	
clean: strategyclean
	rm -f $(PROGS)

strategyclean:
	cd strategy; make clean

test: all $(TESTS)
	
test_perf: $(PERF_TESTS)

test_tuner: $(TUNER_TESTS)
	
install: $(INSTALLFILES)
	$(install_sh_DIR) -d $(INSTALLPATH) ; \
	$(install_sh_PROGRAM) $^ -t $(INSTALLPATH) ; \

$(TESTS): %:%.sh
	TEST_ID=$$PPID  bash $<

PHONY: clean

=== test/strategy/Makefile ===
# SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
#
# Copyright (c) 2023, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License v2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#

SRCARCH := $(shell uname -m | sed -e s/i.86/x86/ -e s/x86_64/x86/ \
				  -e /arm64/!s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/aarch64.*/arm64/ )

CLANG ?= clang
LLC ?= llc
LLVM_STRIP ?= llvm-strip
BPFTOOL ?= bpftool
GCC_BPF ?=
BPF_INCLUDE := /usr/include
BPF_CFLAGS := -g -fno-stack-protector -Wall
NL_INCLUDE := /usr/include/libnl3
INCLUDES := -I../../include -I$(BPF_INCLUDE) -I$(NL_INCLUDE) -I/usr/include/uapi

INSTALL ?= install

DESTDIR ?=
prefix ?= /usr
installprefix = $(DESTDIR)/$(prefix)

INSTALLPATH = $(installprefix)

CFLAGS = -fPIC -Wall -Wextra -march=native -g -I../include -std=c99

CFLAGS += -DBPFTUNE_VERSION='"$(BPFTUNE_VERSION)"' $(INCLUDES)

LDLIBS = -lbpf -ldl -lm -lcap -lpthread

LDFLAGS += -L../../src -L/usr/local/lib64

ifeq ($(V),1)
Q =
else
Q = @
MAKEFLAGS += --no-print-directory
submake_extras := feature_display=0
endif

TUNERS = strategy_tuner

TUNER_OBJS = $(patsubst %,%.o,$(TUNERS))
TUNER_LIBS = $(patsubst %,%.so,$(TUNERS))

BPF_TUNERS = $(patsubst %,%.bpf.o,$(TUNERS))

BPF_OBJS = $(BPF_TUNERS)
LEGACY_BPF_OBJS = $(patsubst %.bpf.o,%.bpf.legacy.o,$(BPF_OBJS))
NOBTF_BPF_OBJS = $(patsubst %.bpf.o,%.bpf.nobtf.o,$(BPF_OBJS))

BPF_SKELS = $(patsubst %,%.skel.h,$(TUNERS))
LEGACY_BPF_SKELS = $(patsubst %.skel.h,%.skel.legacy.h,$(BPF_SKELS))
NOBTF_BPF_SKELS = $(patsubst %.skel.h,%.skel.nobtf.h,$(BPF_SKELS))

.DELETE_ON_ERROR:

.PHONY: clean

all: $(TUNER_LIBS)

clean:
	$(Q)$(RM) *.o *.d *.so*
	$(Q)$(RM) *.skel*.h
	$(Q)$(RM) -r .output

$(TUNER_LIBS): $(BPF_SKELS) $(TUNER_OBJS)
	$(CC) $(CFLAGS) -shared -o $(@) $(patsubst %.so,%.c,$(@)) \
		$(LDLIBS) -lbpftune $(LDFLAGS)

$(TUNER_OBJS): $(BPF_SKELS) $(LEGACY_BPF_SKELS) $(NOBTF_BPF_SKELS)


# check if GCC_BPF flag is set, otherwise use CLANG
ifeq ($(GCC_BPF),)
$(BPF_OBJS): $(patsubst %.o,%.c,$(BPF_OBJS)) ../../include/bpftune/bpftune.bpf.h
	$(CLANG) $(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) -O2 -target bpf \
		$(INCLUDES) -c $(patsubst %.o,%.c,$(@)) -o $(@)

$(LEGACY_BPF_OBJS): $(patsubst %.legacy.o,%.c,$(LEGACY_BPF_OBJS)) ../../include/bpftune/bpftune.bpf.h
	$(CLANG) $(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) -DBPFTUNE_LEGACY -O2 -target bpf \
		$(INCLUDES) -c $(patsubst %.legacy.o,%.c,$(@)) \
		-o $(@)

$(NOBTF_BPF_OBJS): $(patsubst %.nobtf.o,%.c,$(NOBTF_BPF_OBJS)) ../../include/bpftune/bpftune.bpf.h
	$(CLANG) $(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) -DBPFTUNE_NOBTF -O2 -target bpf \
		$(INCLUDES) -c $(patsubst %.nobtf.o,%.c,$(@)) \
		-o $(@)

else
GCC_BPF_FLAGS := -g -O2 \
	$(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) \
	-gbtf -mcpu=v3 -Wno-error=attributes \
	-Wno-error=address-of-packed-member \
	-Wno-compare-distinct-pointer-types \
	$(INCLUDES)

$(BPF_OBJS): $(patsubst %.o,%.c,$(BPF_OBJS)) ../../include/bpftune/bpftune.bpf.h
	$(GCC_BPF) $(GCC_BPF_FLAGS) -c $(patsubst %.o,%.c,$(@)) \
		-o $(@)

$(LEGACY_BPF_OBJS): $(patsubst %.legacy.o,%.c,$(LEGACY_BPF_OBJS)) ../../include/bpftune/bpftune.bpf.h
	$(GCC_BPF) $(GCC_BPF_FLAGS) -DBPFTUNE_LEGACY -c $(patsubst %.legacy.o,%.c,$(@)) \
		-o $(@)

$(NOBTF_BPF_OBJS): $(patsubst %.nobtf.o,%.c,$(NOBTF_BPF_OBJS)) ../../include/bpftune/bpftune.bpf.h
	$(GCC_BPF) $(GCC_BPF_FLAGS) -DBPFTUNE_NOBTF -c $(patsubst %.nobtf.o,%.c,$(@)) \
		-o $(@)

endif

$(BPF_SKELS): $(BPF_OBJS)
	$(BPFTOOL) gen skeleton $(subst .skel.h,.bpf.o,$@) > $@

$(LEGACY_BPF_SKELS): $(LEGACY_BPF_OBJS)
	$(BPFTOOL) gen skeleton $(subst .skel.legacy.h,.bpf.legacy.o,$@) > $(subst .skel.h,.skel.legacy.h,$@)

$(NOBTF_BPF_SKELS): $(NOBTF_BPF_OBJS)
	$(BPFTOOL) gen skeleton $(subst .skel.nobtf.h,.bpf.nobtf.o,$@) > $(subst .skel.h,.skel.nobtf.h,$@)

=== debian/changelog ===
bpftune (0.0~git20241205.2a8d043-1) unstable; urgency=medium

  * Initial release. (Closes: #1087756)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 12 Dec 2024 12:56:12 +0000

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export libdir=lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@

clean:
	dh $@
	rm -f src/*.plist

override_dh_auto_test:
	# no test for now, needs root and more magic.

override_dh_auto_install:
	dh_auto_install
	for sopath in $$(find debian -name 'libbpftune.so'); do \
		ln -sf $$(basename $$sopath.*) $$sopath ; \
	done

## bpftune 0.0~git20250121.d38eac6

=== docs/Makefile ===
# SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
#
# Copyright (c) 2023, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License v2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#

INSTALL ?= install
RM ?= rm -f
RMDIR ?= rmdir --ignore-fail-on-non-empty

ifeq ($(V),1)
  Q =
else
  Q = @
endif

DESTDIR ?=
prefix ?= /usr/share
installprefix = $(DESTDIR)/$(prefix)

mandir ?= $(prefix)/man
man8dir = $(mandir)/man8

MAN8_RST = bpftune.rst bpftune-sysctl.rst bpftune-tcp-conn.rst \
	   bpftune-neigh.rst bpftune-tcp-buffer.rst bpftune-netns.rst \
	   bpftune-net-buffer.rst bpftune-ip-frag.rst

_DOC_MAN8 = $(patsubst %.rst,%.8,$(MAN8_RST))
DOC_MAN8 = $(addprefix $(OUTPUT),$(_DOC_MAN8))

man: man8
man8: $(DOC_MAN8)

RST2MAN_DEP := $(shell command -v rst2man 2>/dev/null)
RST2MAN_OPTS += --verbose

list_pages = $(sort $(basename $(filter-out $(1),$(MAN8_RST))))
see_also = $(subst " ",, \
	"\n" \
	"SEE ALSO\n" \
	"========\n" \
	"\t**bpf**\ (2), **bpftune**\ (8),\n")

$(OUTPUT)%.8: %.rst
	$(QUIET_GEN)( cat $< ; printf "%b" $(call see_also,$<) ) | rst2man $(RST2MAN_OPTS) > $@

clean:
	$(call QUIET_CLEAN, Documentation)
	$(Q)$(RM) $(DOC_MAN8)

install: man
	$(call QUIET_INSTALL, Documentation-man)
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(man8dir)
	$(Q)$(INSTALL) -m 644 $(DOC_MAN8) $(DESTDIR)$(man8dir)

uninstall:
	$(call QUIET_UNINST, Documentation-man)
	$(Q)$(RM) $(addprefix $(DESTDIR)$(man8dir)/,$(_DOC_MAN8))
	$(Q)$(RMDIR) $(DESTDIR)$(man8dir)

.PHONY: man man8 clean install uninstall
.DEFAULT_GOAL := man

=== src/Makefile ===
--- 
+++ 
@@ -27,9 +27,10 @@
 LLVM_STRIP ?= llvm-strip
 BPFTOOL ?= bpftool
 BPF_INCLUDE := /usr/include
+BPF_LOCAL_INCLUDE := /usr/local/include
 BPF_CFLAGS := -g -fno-stack-protector -Wall
 NL_INCLUDE := /usr/include/libnl3
-INCLUDES := -I../include -I$(BPF_INCLUDE) -I$(NL_INCLUDE) -I../include/uapi
+INCLUDES := -I../include -I$(BPF_INCLUDE) -I$(BPF_LOCAL_INCLUDE) -I$(NL_INCLUDE) -I../include/uapi
 INSTALL ?= install
 
 DESTDIR ?= /
@@ -115,6 +116,7 @@
 ifeq ($(GCC_BPF),)
 all: analyze $(OPATH) $(OPATH)bpftune $(TUNER_LIBS)
 else
+BPF_CFLAGS += -std=gnu17
 all: $(OPATH) $(OPATH)bpftune $(TUNER_LIBS)
 endif
 
@@ -193,7 +195,7 @@
 else
 GCC_BPF_FLAGS := -g -O2 \
 	$(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) \
-	-gbtf -mcpu=v3 -Wno-error=attributes \
+	-gbtf -mcpu=v3 -mco-re -Wno-error=attributes \
 	-Wno-error=address-of-packed-member \
 	-Wno-compare-distinct-pointer-types \
 	$(INCLUDES)

=== test/Makefile ===
--- 
+++ 
@@ -24,10 +24,12 @@
 		sample_test sample_legacy_test \
 		strategy_test strategy_legacy_test \
 		rollback_test rollback_legacy_test \
+		query_test \
 		many_netns_test many_netns_legacy_test \
 		podman_globalonly_test podman_globalonly_legacy_test \
 		sysctl_test sysctl_legacy_test sysctl_netns_test \
 		netns_test netns_legacy_test \
+		file_download_test file_download_legacy_test \
 		budget_test \
 		backlog_test backlog_legacy_test \
 		frag_test frag_legacy_test \

=== debian/changelog ===
bpftune (0.0~git20250121.d38eac6-1ubuntu1) plucky; urgency=medium

  * d/control: Change build dep for bpftool on Ubuntu.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 15 Feb 2025 11:36:21 +0000

bpftune (0.0~git20250121.d38eac6-1) unstable; urgency=medium

  * New upstream version 0.0~git20250121.d38eac6
    - Update symbols.
  * find bpftool in Ubuntu.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 14 Feb 2025 19:58:52 +0000

=== debian/control ===
Source: bpftune
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 python3-docutils,
 libbpf-dev,
 libcap-dev,
 clang,
 llvm,
 linux-tools-generic,
 libnl-3-dev,
 libnl-route-3-dev,
 iperf3
Standards-Version: 4.7.0
Homepage: https://github.com/oracle/bpftune/tree/main
Vcs-Browser: https://salsa.debian.org/debian/bpftune
Vcs-Git: https://salsa.debian.org/debian/bpftune.git

Package: bpftune
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: BPF driven auto-tuning
 bpftune aims to provide lightweight, always-on auto-tuning
 of system behaviour via BPF observability.
 .
 bpftune is a daemon which manages a set of tuners, each tuner
 has an associated set of tunables that it manages.

Package: libbpftune0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Library for auto-tuning of Linux via BPF (shared library)
 bpftune aims to provide lightweight, always-on auto-tuning
 of system behaviour via BPF observability.
 .
 This package contains the shared library.

Package: libbpftune-dev
Section: libdevel
Architecture: any
Depends: libbpftune0 (= ${binary:Version}), ${misc:Depends}
Description: Library for auto-tuning of Linux via BPF (development files)
 bpftune aims to provide lightweight, always-on auto-tuning
 of system behaviour via BPF observability.
 .
 This package is needed to compile programs against libbpftune0.

## bpftune 0.0~git20250314.8fd59cc

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
#
# Copyright (c) 2023, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License v2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#

PKG_NAME = `rpmspec -q --queryformat="%{NAME}-%{VERSION}-%{RELEASE}\n" buildrpm/bpftune.spec | head -1`.`uname -m`
PKG_ARCHIVE = `rpmspec -q --queryformat="%{NAME}-%{VERSION}\n" buildrpm/bpftune.spec | head -1`
PKG_DIR ?=  ${HOME}/rpmbuild
SRC_DIR = $(PKG_DIR)/SOURCES
THIS_DIR = `basename $PWD`
LICENSEDIR ?= $(PKG_DIR)/BUILD
BUILD_DIR = $(PKG_DIR)/BUILDROOT/$(PKG_NAME)

DESTDIR ?=
prefix ?= /usr
installprefix ?= $(DESTDIR)/$(prefix)

INSTALLPATH = $(installprefix)

.DELETE_ON_ERROR:

.PHONY: all clean

all: srcdir docdir testdir
	
srcdir:
	cd src; make
docdir:
	cd docs; make man

testdir: srcdir
	cd test; make

test:	FORCE
	cd test; make test

pkg:    all
	mkdir -p $(SRC_DIR) $(BUILD_DIR) $(BUILD_DIR)/$(prefix) $(LICENSEDIR);\
	rm -fr $(SRC_DIR)/$(PKG_ARCHIVE)* ;\
	git archive --format=tar --prefix=$(PKG_ARCHIVE)/ -o $(SRC_DIR)/$(PKG_ARCHIVE).tar HEAD;\
	bzip2 $(SRC_DIR)/$(PKG_ARCHIVE).tar ; \
	cp -pr LICENSE* $(LICENSEDIR) ;\
	DESTDIR=$(BUILD_DIR) installprefix=$(BUILD_DIR)/$(prefix) rpmbuild --define "_topdir $(PKG_DIR)" -ba buildrpm/bpftune.spec

FORCE:
	
clean: srcclean docclean testclean

distclean: clean distclean_src
	
srcclean:
	cd src; make clean
docclean:
	cd docs; make clean
distclean_src:
	cd src; make distclean
testclean:
	cd test; make clean

install: srcinstall includeinstall docinstall
	
srcinstall:
	cd src; make install
includeinstall:
	cd include; make install
docinstall:
	cd docs; make install

=== src/Makefile ===
--- 
+++ 
@@ -17,6 +17,7 @@
 # Boston, MA 021110-1307, USA.
 #
 
+ARCH ?= $(shell uname -m)
 SRCARCH ?= $(shell uname -m | sed -e s/i.86/x86/ -e s/x86_64/x86/ \
 				  -e /arm64/!s/arm.*/arm/ -e s/sa110/arm/ \
 				  -e s/aarch64.*/arm64/ )
@@ -28,7 +29,7 @@
 BPFTOOL ?= bpftool
 BPF_INCLUDE := /usr/include
 BPF_LOCAL_INCLUDE := /usr/local/include
-BPF_CFLAGS := -g -fno-stack-protector -Wall
+BPF_CFLAGS := -g -fno-stack-protector -Wall -Wno-incompatible-pointer-types-discards-qualifiers
 NL_INCLUDE := /usr/include/libnl3
 INCLUDES := -I../include -I$(BPF_INCLUDE) -I$(BPF_LOCAL_INCLUDE) -I$(NL_INCLUDE) -I../include/uapi
 INSTALL ?= install
@@ -74,6 +75,14 @@
 VMLINUX_BTF_PATHS := /sys/kernel/btf/vmlinux /boot/vmlinux-$(KERNEL_REL)
 VMLINUX_BTF_PATH := $(or $(VMLINUX_BTF),$(firstword			       \
 					  $(wildcard $(VMLINUX_BTF_PATHS))))
+
+# Some systems ship with a vmlinux.h; use it.
+VMLINUX_H_PATH ?= /usr/include/$(ARCH)-linux-gnu/linux/bpf/
+VMLINUX_H_FILE := $(wildcard $(VMLINUX_H_PATH)/vmlinux.h)
+
+ifneq ($(VMLINUX_H_FILE),)
+BPF_CFLAGS += -DVMLINUX_H -I$(VMLINUX_H_PATH)
+endif
 
 OPATH :=
 ifeq ($(SANITIZE),1)

=== test/Makefile ===
--- 
+++ 
@@ -18,13 +18,13 @@
 #
 
 
-PERF_TESTS = iperf3_test qperf_test
+PERF_TESTS = stress_ng_test iperf3_test qperf_test
 
 TUNER_TESTS =	support_test log_test service_test inotify_test cap_test \
 		sample_test sample_legacy_test \
 		strategy_test strategy_legacy_test \
 		rollback_test rollback_legacy_test \
-		query_test \
+		query_test rate_test \
 		many_netns_test many_netns_legacy_test \
 		podman_globalonly_test podman_globalonly_legacy_test \
 		sysctl_test sysctl_legacy_test sysctl_netns_test \
@@ -37,6 +37,7 @@
 		neigh_table_legacy_test \
 		mem_pressure_test mem_pressure_legacy_test \
 		mem_exhaust_test mem_exhaust_legacy_test \
+		good_syn_flood_test syn_flood_test \
 		wmem_test wmem_legacy_test \
 		rmem_test rmem_legacy_test \
 		cong_test cong_legacy_test
@@ -48,6 +49,8 @@
 LIBS = test_lib.sh
 
 PROGS = conn_bomb
+
+CFLAGS += -lpthread
 
 OBJS = conn_bomb.o

=== debian/changelog ===
bpftune (0.0~git20250314.8fd59cc-1) unstable; urgency=medium

  [ Bernd Zeimetz ]
  ** SNAPSHOT build @126642eb27cb81198d95974b3942478f7b2fd457 **

  * [c668e88] New upstream version 0.0~git20250312.6de24b9
  * Snapshot changelog

  [ Sudip Mukherjee ]
  * New upstream version 0.0~git20250314.8fd59cc
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 17 Mar 2025 17:29:23 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: bpftune
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -11,7 +10,7 @@
  libcap-dev,
  clang,
  llvm,
- linux-tools-generic,
+ bpftool,
  libnl-3-dev,
  libnl-route-3-dev,
  iperf3

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,22 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export libdir=lib/$(DEB_HOST_MULTIARCH)
+
+# On Ubuntu, the `bpftool` in path is a shell wrapper pointing at
+# the binary corresponding to runtime kernel version.
+#
+# We do not know the kernel version being used on the system building
+# this package, and in sbuild/container environments uname might not
+# even match anything available to the build.
+# Gladly for the build we only need the tool to generate skeleton code.
+#
+# If any /usr/lib/linux-tools/*/bpftool exists, locate the most recent
+# version and point to that, otherwise `bpftool` from PATH will be
+# used.
+bpftool_binary := $(shell find -L /usr/lib/linux-tools/ -name 'bpftool' -perm /u=x 2>/dev/null | sort | head -n1)
+ifneq ($(bpftool_binary),)
+export BPFTOOL=$(bpftool_binary)
+endif
 
 %:
 	dh $@

## bpftune 0.0~git20250723.5966387

=== Makefile ===
--- 
+++ 
@@ -71,7 +71,7 @@
 testclean:
 	cd test; make clean
 
-install: srcinstall includeinstall docinstall
+install: srcinstall includeinstall docinstall pcpinstall
 	
 srcinstall:
 	cd src; make install
@@ -79,3 +79,5 @@
 	cd include; make install
 docinstall:
 	cd docs; make install
+pcpinstall:
+	cd src/pcp; make install

=== docs/Makefile ===
--- 
+++ 
@@ -36,7 +36,7 @@
 
 MAN8_RST = bpftune.rst bpftune-sysctl.rst bpftune-tcp-conn.rst \
 	   bpftune-neigh.rst bpftune-tcp-buffer.rst bpftune-netns.rst \
-	   bpftune-net-buffer.rst bpftune-ip-frag.rst
+	   bpftune-net-buffer.rst bpftune-ip-frag.rst bpftune-udp-buffer.rst
 
 _DOC_MAN8 = $(patsubst %.rst,%.8,$(MAN8_RST))
 DOC_MAN8 = $(addprefix $(OUTPUT),$(_DOC_MAN8))

=== include/Makefile ===
# SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
#
# Copyright (c) 2023, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License v2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#

INSTALLFILES = $(wildcard bpftune/*.h)

DESTDIR ?=
prefix ?= /usr
installprefix ?= $(DESTDIR)/$(prefix)

INSTALLPATH = $(installprefix)/include

install_sh_HDR = install -m 0444
install_sh_DIR = install -dv

all:
	
install: $(INSTALLFILES)
	$(install_sh_DIR) -d $(INSTALLPATH)/bpftune ; \
	$(install_sh_HDR) $^ -t $(INSTALLPATH)/bpftune ; \

=== sample_tuner/Makefile ===
# SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
#
# Copyright (c) 2023, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License v2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#

SRCARCH := $(shell uname -m | sed -e s/i.86/x86/ -e s/x86_64/x86/ \
				  -e /arm64/!s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/aarch64.*/arm64/ )

CLANG ?= clang
LLC ?= llc
LLVM_STRIP ?= llvm-strip
BPFTOOL ?= bpftool
BPF_INCLUDE := /usr/include
NL_INCLUDE := /usr/include/libnl3
INCLUDES := -I$(BPF_INCLUDE) -I$(NL_INCLUDE) -I/usr/include/uapi

INSTALL ?= install

DESTDIR ?=
prefix ?= /usr
installprefix = $(DESTDIR)/$(prefix)

INSTALLPATH = $(installprefix)

CFLAGS = -fPIC -Wall -Wextra -march=native -g -I../include -std=c99

CFLAGS += -DBPFTUNE_VERSION='"$(BPFTUNE_VERSION)"' $(INCLUDES)

LDLIBS = -lbpf -ldl -lm -lcap -lpthread

LDFLAGS += -L. -L/usr/local/lib64

ifeq ($(V),1)
Q =
else
Q = @
MAKEFLAGS += --no-print-directory
submake_extras := feature_display=0
endif

TUNERS = sample_tuner

TUNER_OBJS = $(patsubst %,%.o,$(TUNERS))
TUNER_LIBS = $(patsubst %,%.so,$(TUNERS))

BPF_TUNERS = $(patsubst %,%.bpf.o,$(TUNERS))

BPF_OBJS = $(BPF_TUNERS)

BPF_SKELS = $(patsubst %,%.skel.h,$(TUNERS))

.DELETE_ON_ERROR:

.PHONY: clean

all: $(TUNER_LIBS)
	
clean:
	$(Q)$(RM) *.o *.d *.so*
	$(Q)$(RM) *.skel*.h
	$(Q)$(RM) -r .output

install: all
	$(INSTALL) -m 0755 -d $(INSTALLPATH)/local/lib64
	$(INSTALL) -m 0755 -d $(INSTALLPATH)/local/lib64/bpftune
	$(INSTALL) $(TUNER_LIBS) $(INSTALLPATH)/local/lib64/bpftune

$(TUNER_LIBS): $(BPF_SKELS) $(TUNER_OBJS)
	$(CC) $(CFLAGS) -shared -o $(@) $(patsubst %.so,%.c,$(@)) \
		$(LDLIBS) -lbpftune $(LDFLAGS)

%.skel.h: %.bpf.o
	$(QUIET_GEN)$(BPFTOOL) gen skeleton $< > $@

$(BPF_OBJS): $(patsubst %.o,%.c,$(BPF_OBJS)) ../include/bpftune/bpftune.bpf.h
	$(CLANG) -g -D__TARGET_ARCH_$(SRCARCH) -O2 -target bpf		\
		$(INCLUDES) -c $(patsubst %.o,%.c,$(@)) -o $(@);
	$(CLANG) -g -D__TARGET_ARCH_$(SRCARCH) -DBPFTUNE_LEGACY -O2 -target bpf \
		$(INCLUDES) -c $(patsubst %.o,%.c,$(@)) \
		-o $(patsubst %.o,%.legacy.o,$(@));
	$(CLANG) -g -D__TARGET_ARCH_$(SRCARCH) -DBPFTUNE_NOBTF -DBPFTUNE_LEGACY -O2 -target bpf \
		$(INCLUDES) -c $(patsubst %.o,%.c,$(@)) \
		-o $(patsubst %.o,%.nobtf.o,$(@));

$(BPF_SKELS): $(BPF_OBJS)
	$(BPFTOOL) gen skeleton $(subst .skel.h,.bpf.o,$@) > $@ ;\
	$(BPFTOOL) gen skeleton $(subst .skel.h,.bpf.legacy.o,$@) > $(subst .skel.h,.skel.legacy.h,$@);\
	$(BPFTOOL) gen skeleton $(subst .skel.h,.bpf.nobtf.o,$@) > $(subst .skel.h,.skel.nobtf.h,$@)

=== src/Makefile ===
--- 
+++ 
@@ -56,7 +56,7 @@
 BPFTUNE_VERSION := $(KERNEL_REL)-$(GIT_SHA)
 endif
 
-VERSION = 0.1.3
+VERSION = 0.2.1
 VERSION_SCRIPT  := libbpftune.map
 
 CFLAGS = -fPIC -Wall -Wextra -g -I../include -std=c99
@@ -99,7 +99,8 @@
 endif
 
 TUNERS = tcp_buffer_tuner route_table_tuner neigh_table_tuner sysctl_tuner \
-	 tcp_conn_tuner netns_tuner net_buffer_tuner ip_frag_tuner
+	 tcp_conn_tuner netns_tuner net_buffer_tuner ip_frag_tuner \
+	 udp_buffer_tuner
 
 TUNER_OBJS = $(patsubst %,%.o,$(TUNERS))
 TUNER_SRCS = $(patsubst %,%.c,$(TUNERS))
@@ -155,6 +156,10 @@
 	$(INSTALL) $(TUNER_LIBS) $(INSTALLPATH)/$(libdir)/bpftune
 	$(INSTALL) -m 0755 -d $(CONF)
 	$(INSTALL) -m 0755 -d $(CONFPATH)
+	$(INSTALL) -m 0755 -d $(CONF)/conf.d
+	$(INSTALL) -m 0755 -d $(CONF)/init.d
+	$(INSTALL) -m 0644 bpftune.confd $(CONF)/conf.d/bpftune
+	$(INSTALL) -m 0755 bpftune.initd $(CONF)/init.d/bpftune
 	echo $(prefix)/$(libdir) > $(CONFPATH)/libbpftune.conf
 	if [ $(DESTDIR) =  / ]; then ldconfig; fi

=== test/Makefile ===
--- 
+++ 
@@ -25,11 +25,14 @@
 		strategy_test strategy_legacy_test \
 		rollback_test rollback_legacy_test \
 		query_test rate_test \
+		pcp_pmda_test \
 		many_netns_test many_netns_legacy_test \
 		podman_globalonly_test podman_globalonly_legacy_test \
 		sysctl_test sysctl_legacy_test sysctl_netns_test \
 		netns_test netns_legacy_test \
 		file_download_test file_download_legacy_test \
+		udp_rmem_test udp_rmem_legacy_test \
+		udp_rmem_locked_test udp_mem_exhaust_test \
 		budget_test \
 		backlog_test backlog_legacy_test \
 		frag_test frag_legacy_test \

=== src/pcp/Makefile ===
# SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note
#
# Copyright (c) 2023, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License v2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#


INSTALLFILES = Install Remove pmdabpftune.python

DESTDIR ?=
prefix ?= /usr
installprefix ?= $(DESTDIR)/$(prefix)

INSTALLPATH = $(installprefix)/../var/lib/pcp/pmdas/bpftune

install_sh_PROGRAM = install
install_sh_DIR = install -dv

all:
	
PHONY: clean
	
clean:

test:
	
install: $(INSTALLFILES)
	$(install_sh_DIR) -d $(INSTALLPATH) ; \
	$(install_sh_PROGRAM) $^ -t $(INSTALLPATH) ; \
	install README -t $(INSTALLPATH);

PHONY: clean

=== test/strategy/Makefile ===
--- 
+++ 
@@ -106,7 +106,7 @@
 
 else
 GCC_BPF_FLAGS := -g -O2 \
-	$(BPF_CFLAGS) -D__TARGET_ARCH_$(SRCARCH) \
+	$(BPF_CFLAGS) -std=gnu17 -D__TARGET_ARCH_$(SRCARCH) \
 	-gbtf -mcpu=v3 -Wno-error=attributes \
 	-Wno-error=address-of-packed-member \
 	-Wno-compare-distinct-pointer-types \

=== debian/changelog ===
bpftune (0.0~git20250723.5966387-1) unstable; urgency=medium

  * New upstream version 0.0~git20250723.5966387
    - Update lintian overrides.
    - Update symbols.
  * Update Standards-Version to 4.7.2
  * Add new package for pcp-pmda-bpftune.
    - Add new lintian overrides for pcp interpreter.
    - Fix permission of README.
  * Remove old fsf address from d/copyright.
  * Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 01 Sep 2025 19:04:08 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libnl-3-dev,
  libnl-route-3-dev,
  iperf3
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/oracle/bpftune/tree/main
 Vcs-Browser: https://salsa.debian.org/debian/bpftune
 Vcs-Git: https://salsa.debian.org/debian/bpftune.git
@@ -51,3 +51,15 @@
  of system behaviour via BPF observability.
  .
  This package is needed to compile programs against libbpftune0.
+
+Package: pcp-pmda-bpftune
+Architecture: any
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends},
+ bpftune (= ${binary:Version}),
+ pcp,
+ python3-pcp
+Description: Performance Co-Pilot PMDA for bpftune
+ pcp-pmda-bpftune exports tunables and metrics from bpftune
+ to Performance Co-Pilot (PCP)

=== debian/rules ===
--- 
+++ 
@@ -35,3 +35,7 @@
 	for sopath in $$(find debian -name 'libbpftune.so'); do \
 		ln -sf $$(basename $$sopath.*) $$sopath ; \
 	done
+
+override_dh_fixperms:
+	dh_fixperms
+	chmod 0644 debian/pcp-pmda-bpftune/var/lib/pcp/pmdas/bpftune/README

=== debian/watch ===
version=4

opts="mode=git" \
    https://github.com/oracle/bpftune.git HEAD

## bpftune 0.0~git20251206.4bcc284

=== src/Makefile ===
--- 
+++ 
@@ -56,7 +56,7 @@
 BPFTUNE_VERSION := $(KERNEL_REL)-$(GIT_SHA)
 endif
 
-VERSION = 0.2.1
+VERSION = 0.3.2
 VERSION_SCRIPT  := libbpftune.map
 
 CFLAGS = -fPIC -Wall -Wextra -g -I../include -std=c99
@@ -173,8 +173,7 @@
 			-shared -o $(@).$(VERSION) \
 			$(patsubst %.so,%.o,$(@)) \
 			$(LDLIBS) $(LDFLAGS) ; \
-	rm -f $(@) ; \
-	ln -sr $(@).$(VERSION) $(@)
+	ln -fsr $(@).$(VERSION) $(@)
 
 $(TUNER_OBJS): $(BPF_SKELS) $(LEGACY_BPF_SKELS) $(NOBTF_BPF_SKELS)

=== test/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 PERF_TESTS = stress_ng_test iperf3_test qperf_test
 
-TUNER_TESTS =	support_test log_test service_test inotify_test cap_test \
+GENERAL_TESTS =	support_test log_test service_test inotify_test cap_test \
 		sample_test sample_legacy_test \
 		strategy_test strategy_legacy_test \
 		rollback_test rollback_legacy_test \
@@ -29,23 +29,33 @@
 		many_netns_test many_netns_legacy_test \
 		podman_globalonly_test podman_globalonly_legacy_test \
 		sysctl_test sysctl_legacy_test sysctl_netns_test \
-		netns_test netns_legacy_test \
-		file_download_test file_download_legacy_test \
-		udp_rmem_test udp_rmem_legacy_test \
-		udp_rmem_locked_test udp_mem_exhaust_test \
-		budget_test \
-		backlog_test backlog_legacy_test \
-		frag_test frag_legacy_test \
-		neigh_table_test neigh_table_v4only_test \
-		neigh_table_legacy_test \
-		mem_pressure_test mem_pressure_legacy_test \
-		mem_exhaust_test mem_exhaust_legacy_test \
-		good_syn_flood_test syn_flood_test \
-		wmem_test wmem_legacy_test \
-		rmem_test rmem_legacy_test \
-		cong_test cong_legacy_test
+		netns_test netns_legacy_test cgroup_cleanup_test
 
-DEFAULT_TESTS = $(TUNER_TESTS) $(PERF_TESTS)
+IP_FRAG_TESTS =		frag_test frag_legacy_test
+
+NEIGH_TABLE_TESTS =	neigh_table_test neigh_table_v4only_test \
+			neigh_table_max_test neigh_table_max2_test \
+			neigh_table_legacy_test
+
+NET_BUFFER_TESTS =	budget_test backlog_test backlog_legacy_test \
+			high_order_alloc_test
+
+TCP_BUFFER_TESTS =	mem_pressure_test mem_pressure_legacy_test \
+			mem_exhaust_test mem_exhaust_legacy_test \
+			good_syn_flood_test syn_flood_test \
+			wmem_test wmem_legacy_test \
+			rmem_test rmem_legacy_test
+
+TCP_CONN_TESTS =	cong_test cong_legacy_test \
+			file_download_test file_download_legacy_test
+
+UDP_BUFFER_TESTS =	udp_rmem_test udp_rmem_legacy_test \
+			udp_rmem_locked_test udp_mem_exhaust_test
+
+TUNER_TESTS =	$(IP_FRAG_TESTS) $(NEIGH_TABLE_TESTS) $(NET_BUFFER_TESTS) \
+		$(TCP_BUFFER_TESTS) $(TCP_CONN_TESTS) $(UDP_BUFFER_TESTS)
+
+DEFAULT_TESTS = $(GENERAL_TESTS) $(TUNER_TESTS) $(PERF_TESTS)
 
 TESTS = $(DEFAULT_TESTS)
 
@@ -87,6 +97,20 @@
 
 test_tuner: $(TUNER_TESTS)
 	
+test_general: $(GENERAL_TESTS)
+	
+test_ip_frag: $(IP_FRAG_TESTS)
+	
+test_neigh_table: $(NEIGH_TABLE_TESTS)
+	
+test_net_buffer: $(NET_BUFFER_TESTS)
+	
+test_tcp_buffer: $(TCP_BUFFER_TESTS)
+	
+test_tcp_conn: $(TCP_CONN_TESTS)
+	
+test_udp_buffer: $(UDP_BUFFER_TESTS)
+	
 install: $(INSTALLFILES)
 	$(install_sh_DIR) -d $(INSTALLPATH) ; \
 	$(install_sh_PROGRAM) $^ -t $(INSTALLPATH) ; \

=== debian/changelog ===
bpftune (0.0~git20251206.4bcc284-1) unstable; urgency=medium

  * New upstream version 0.0~git20251206.4bcc284
    - Update symbols.
    - Update lintian override.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 07 Dec 2025 17:01:52 +0000
